<!--|This file generated by command(leetcode description); DO NOT EDIT.    |-->
<!--+----------------------------------------------------------------------+-->
<!--|@author    openset <openset.wang@gmail.com>                           |-->
<!--|@link      https://github.com/openset                                 |-->
<!--|@home      https://github.com/openset/leetcode                        |-->
<!--+----------------------------------------------------------------------+-->

[< Previous](../meeting-rooms "Meeting Rooms")
　　　　　　　　　　　　　　　　
[Next >](../factor-combinations "Factor Combinations")

## [253. Meeting Rooms II (Medium)](https://leetcode.com/problems/meeting-rooms-ii "会议室 II")

<p>Given an array of meeting time intervals consisting of start and end times <code>[[s1,e1],[s2,e2],...]</code> (s<sub>i</sub> &lt; e<sub>i</sub>), find the minimum number of conference rooms required.</p>

<p><strong>Example 1:</strong></p>

<pre>
<strong>Input:</strong> <code>[[0, 30],[5, 10],[15, 20]]</code>
<strong>Output:</strong> 2</pre>

<p><b>Example 2:</b></p>

<pre>
<b>Input:</b> [[7,10],[2,4]]
<b>Output:</b> 1</pre>

<p><strong>NOTE:</strong>&nbsp;input types have been changed on April 15, 2019. Please reset to default code definition to get new method signature.</p>

### Related Topics
  [[Heap](../../tag/heap/README.md)]
  [[Greedy](../../tag/greedy/README.md)]
  [[Sort](../../tag/sort/README.md)]

### Similar Questions
  1. [Merge Intervals](../merge-intervals) (Medium)
  1. [Meeting Rooms](../meeting-rooms) (Easy)
  1. [Minimum Number of Arrows to Burst Balloons](../minimum-number-of-arrows-to-burst-balloons) (Medium)
  1. [Car Pooling](../car-pooling) (Medium)

### Hints
<details>
<summary>Hint 1</summary>
Think about how we would approach this problem in a very simplistic way. We will allocate rooms to meetings that occur earlier in the day v/s the ones that occur later on, right?
</details>

<details>
<summary>Hint 2</summary>
If you've figured out that we have to <b>sort</b> the meetings by their start time, the next thing to think about is how do we do the allocation? <br>There are two scenarios possible here for any meeting. Either there is no meeting room available and a new one has to be allocated, or a meeting room has freed up and this meeting can take place there.
</details>

<details>
<summary>Hint 3</summary>
An important thing to note is that we don't really care <b>which</b> room gets freed up while allocating a room for the current meeting. As long as a room is free, our job is done. <br><br>We already know the rooms we have allocated till now and we also know when are they due to get free because of the end times of the meetings going on in those rooms. We can simply check the room which is due to get vacated the earliest amongst all the allocated rooms.
</details>

<details>
<summary>Hint 4</summary>
Following up on the previous hint, we can make use of a min-heap to store the end times of the meetings in various rooms. <br><br>So, every time we want to check if any room is free or not, simply check the topmost element of the min heap as that would be the room that would get free the earliest out of all the other rooms currently occupied.

<br><br>If the room we extracted from the top of the min heap isn't free, then no other room is. So, we can save time here and simply allocate a new room.
</details>
